#include <bits/stdc++.h>
using namespace std;

int br[26];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,k;
    cin >> n >> k;
    char a;
    vector<int>izlaz;
    for ( int i = 0 ; i < n; i++)
    {
        cin >> a;
        br[int(a)-'a']++;
        int m = 10e9;
        for ( int j = 0 ; j < k ; j++) m = min(m,br[j]);
        izlaz.push_back(m+1);
    }
    for ( int i = 0 ; i < n ; i ++) cout << izlaz[i] << " ";

}